/*
  Copyright (c) 2012-2013 Yoshihide Yoshimoto
 */

#include <stdio.h>
#include <stdlib.h>

#define EXTFORT(symbol) symbol##_

static int
modulo(int i, int j) {
	int q;
	q = i/j;
	if (i < 0) { q = q - 1; }
	return (i - q*j);
}

static int
msbq() {
	union {
		unsigned int i;
		unsigned char c[4];
	} test;

	test.i = 1;
	if ( test.c[0] != 0) {
		return 0;
	} else {
		return 1;
	}
}

void
EXTFORT(outzfldprsk)(char *ofname, char *name,
		 int *nx, int *ny, int *nz, double delta[3][3], double origin[3],
		 int *nspin,
		 int *nlx, int *nly, int *nlz, double *fld, int *wflt,
		 double sk[3], double *ee, int *mxp, int iorg[3]) {

    const double oneau = 0.529177249;

    int i, j, k, ic;
	FILE *fp;
	char *endian;

	float ftmp[2];
	double tmp[2];
	double *fldr, *fldi;

	fp = fopen(ofname, "w+");
	if (fp == NULL) {
		fprintf(stderr, "invalid ofname %s\n", ofname);
		exit(1);
	}

    fprintf(fp, "object 1 class gridpositions counts %d %d %d\n",
			*nx+*mxp, *ny+*mxp, *nz+*mxp);
    fprintf(fp, "origin %16.8e %16.8e %16.8e\n",
			origin[0], origin[1], origin[2]);
	fprintf(fp, "delta %16.8e %16.8e %16.8e\n",
			delta[0][0], delta[0][1], delta[0][2]);
	fprintf(fp, "delta %16.8e %16.8e %16.8e\n",
			delta[1][0], delta[1][1], delta[1][2]);
	fprintf(fp, "delta %16.8e %16.8e %16.8e\n",
			delta[2][0], delta[2][1], delta[2][2]);
    fprintf(fp,"object 2 class gridconnections counts %d %d %d\n",
			*nx+*mxp, *ny+*mxp, *nz+*mxp);

	fprintf(fp, "object 3 class array type double rank 1 shape 3\n");
    fprintf(fp, "items 1 text data follows\n");
	fprintf(fp, "%24.16e %24.16e %24.16e\n",sk[0],sk[1],sk[2]);

	if (*wflt) {
		fprintf(fp, "object 4 class array type float category complex rank 0\n");
	} else {
		fprintf(fp, "object 4 class array type double category complex rank 0\n");
	}
	if (msbq()) {
		endian = "msb";
	} else {
		endian = "lsb";
	}
    fprintf(fp, "items %d %s ieee data follows\n",
			(*nx+*mxp)*(*ny+*mxp)*(*nz+*mxp), endian);
	fldr = fld;
	fldi = fld + (*nlx)*(*nly)*(*nlz);
	for(k=iorg[2]; k<*nx+*mxp+iorg[2]; k++) {
		for(j=iorg[1]; j<*ny+*mxp+iorg[1]; j++) {
			for(i=iorg[0]; i<*nz+*mxp+iorg[0]; i++) {
				ic = (*nlx)*(*nly)*modulo(i,*nz) +
					(*nlx)*modulo(j,*ny) + modulo(k,*nx);
				if (*wflt) {
					ftmp[0] = fldr[ic];
					ftmp[1] = fldi[ic];
					fwrite(&ftmp, sizeof(float), 2, fp);
				} else {
					tmp[0] = fldr[ic];
					tmp[1] = fldi[ic];
					fwrite(&tmp, sizeof(double), 2, fp);
				}
			}
		}
	}
	fprintf(fp, "\n");
	fprintf(fp, "attribute \"dep\" string \"positions\"\n");
	if (*nspin == 2) {
		if (*wflt) {
			fprintf(fp, "object 5 class array type float category complex rank 0\n");
		} else {
			fprintf(fp, "object 5 class array type double category complex rank 0\n");
		}
		if (msbq()) {
			endian = "msb";
		} else {
			endian = "lsb";
		}
		fprintf(fp, "items %d %s ieee data follows\n",
				(*nx+*mxp)*(*ny+*mxp)*(*nz+*mxp), endian);
		fldr = fld + 2*(*nlx)*(*nly)*(*nlz);
		fldi = fld + 3*(*nlx)*(*nly)*(*nlz);
		for(k=iorg[2]; k<*nx+*mxp+iorg[2]; k++) {
			for(j=iorg[1]; j<*ny+*mxp+iorg[1]; j++) {
				for(i=iorg[0]; i<*nz+*mxp+iorg[0]; i++) {
					ic = (*nlx)*(*nly)*modulo(i,*nz) +
						(*nlx)*modulo(j,*ny) + modulo(k,*nx);
					if (*wflt) {
						ftmp[0] = fldr[ic];
						ftmp[1] = fldi[ic];
						fwrite(&ftmp, sizeof(float), 2, fp);
					} else {
						tmp[0] = fldr[ic];
						tmp[1] = fldi[ic];
						fwrite(&tmp, sizeof(double), 2, fp);
					}
				}
			}
		}
		fprintf(fp, "\n");
		fprintf(fp, "attribute \"dep\" string \"positions\"\n");
	}

	if (*nspin == 1) {
		fprintf(fp, "object 5 class field\n");
		fprintf(fp, "component \"positions\" value 1\n");
		fprintf(fp, "component \"connections\" value 2\n");
		fprintf(fp, "component \"data\" value 4\n");

		fprintf(fp, "object 6 class array type double rank 1 shape 1\n");
		fprintf(fp, "items 1 text data follows\n");
		fprintf(fp, "%24.16e\n",ee[0]);
	} else {
		fprintf(fp, "object 6 class field\n");
		fprintf(fp, "component \"positions\" value 1\n");
		fprintf(fp, "component \"connections\" value 2\n");
		fprintf(fp, "component \"data\" value 4\n");
		fprintf(fp, "object 7 class field\n");
		fprintf(fp, "component \"positions\" value 1\n");
		fprintf(fp, "component \"connections\" value 2\n");
		fprintf(fp, "component \"data\" value 5\n");

		fprintf(fp, "object 8 class array type double rank 1 shape 1\n");
		fprintf(fp, "items 1 text data follows\n");
		fprintf(fp, "%24.16e\n",ee[0]);
		fprintf(fp, "object 9 class array type double rank 1 shape 1\n");
		fprintf(fp, "items 1 text data follows\n");
		fprintf(fp, "%24.16e\n",ee[1]);
	}

	fprintf(fp, "object \"%s\" class group\n", name);
	if (*nspin == 1) {
		fprintf(fp, "member \"spin1\" 5\n");
		fprintf(fp, "member \"sk\" 3\n");
		fprintf(fp, "member \"ee1\" 6\n");
	} else {
		fprintf(fp, "member \"spin1\" 6\n");
		fprintf(fp, "member \"spin2\" 7\n");
		fprintf(fp, "member \"sk\" 3\n");
		fprintf(fp, "member \"ee1\" 8\n");
		fprintf(fp, "member \"ee2\" 9\n");
	}
    fprintf(fp, "end\n");

    fclose(fp);
	return;
}
