!
! Copyright (c) 1983-2000,2012-2013 TAPP Consortium
! Copyright (c) 2012-2013 Yoshihide Yoshimoto
!
module subr_rdolddata
contains
  subroutine rddata(ax,bx,aa,bb,va,vb,ng,nsv,nnp,rg,pg,nsymq &
       ,qf,rf,qm,qc,beta,qbtp,qexat &
       ,nkd,nsi,kd,asi,mkd &
       ,nband,nspin,znext,dspin &
       ,nrx,nry,nrz,nrxyz,ntt,ngx,ngy,ngz,ngxyz,nhx,nhy,nhz &
       ,qwf,nwx,nwy,nwz &
       ,ndx,ndy,ndz,nk,nw,nb1,nb2,mmm,nsk &
       ,idat,iopt,nopt,ismode,nmkd,tim,eps,eepsa,feps,ekbt &
       ,niter0,niter1,itsb,ndiag0,ndiag1,ncycl,nrfr,most &
       ,decr,okatom,uptime,ifcg,nf,mssg)
    !
    use util
    implicit none
    double precision ax,bx,va,vb,qf,rf,qm,qc,qwf,beta,znext,dspin
    double precision qbtp(3),qexat(2)
    double precision eps,eepsa,feps,ekbt,decr,okatom
    double precision uptime
    integer ng,nsv,nnp,nsymq,nkd,nsi,nband,nspin
    integer nk,nw,nb1,nb2,nsk,nopt,ismode,nmkd
    integer ndiag0,ndiag1,ncycl,nrfr,most,niter0,niter1,itsb
    integer nrx,nry,nrz,nrxyz,ntt,ngx,ngy,ngz,ngxyz,nwx,nwy,nwz
    integer nhx,nhy,nhz,ndx,ndy,ndz
    integer mmm(:,:,:),idat(3)
    integer iopt(nopt)
    double precision tim(:,:,:)
    pointer mmm,tim
    integer ifcg,nf,mssg
    !
    double precision pi
    parameter(pi=3.1415926535897932385d0)
    !
    ! latgen
    double precision aa(3,3),bb(3,3)
    ! symgen
    integer rg(3,3,nsymq),pg(3,nsymq)
    ! atmgen
    integer kd(:)
    double precision asi(:,:)
    integer mkd(:)
    pointer kd,asi,mkd
    ! lattice interval
    double precision h(3)
    integer i,j,ig,it,imkd,gctr(3)
    character*80 cinput,csave
    character(len=256) cbuff
    !
    integer kdmax
    integer nask
    parameter(nask=3)
    integer tmmm(:,:,:)
    pointer tmmm
    integer ier

    integer ios
    logical flg
    !
    ! latgen
    read(nf,*) ax
    read(nf,*) aa(1,1),aa(2,1),aa(3,1)
    read(nf,*) aa(1,2),aa(2,2),aa(3,2)
    read(nf,*) aa(1,3),aa(2,3),aa(3,3)
    call latgen(ax,bx,aa,bb,va,vb,mssg)
    !
    ! symgen
    read(nf,'(a256)') cbuff
    read(cbuff,*,iostat=ier) ng,nsv,nnp,nspin,ismode
    if (ier .ne. 0) then
       read(cbuff,*) ng,nsv,nnp
       nspin = 1
       ismode = 1
    end if
    if ( (nspin .ne. 1) .and. (nspin .ne. 2) ) then
       if (mssg.gt.-1) write(6,'(1x,a,i2)') &
            'invalid value in nspin = ', nspin
       stop
    end if
    if ( (ismode .ne. 1) .and. (ismode .ne. 2) ) then
       if (mssg.gt.-1) write(6,'(1x,a,i2)') &
            'invalid value in ismode = ', ismode
       stop
    end if
    if ( (nsv .ne. 0) .and. (nsv .ne. 1 ) ) then
       if (mssg.gt.-1) write(6,'(1x,a,i2)') 'invalid nsv = ', nsv
       stop
    end if
    if (ng.gt.nsymq) then
       if (mssg.gt.-1) write(6,'(1x,a,i2)') 'ng > nsymq'
       stop
    end if
    read(nf,200) (((rg(i,j,ig),i=1,3),j=1,3),ig=1,ng)
    read(nf,300) ((pg(i,ig),i=1,3),ig=1,ng)
200 format(9i3)
300 format(6(3i3,3x))
    !
    ! atmvb
    read(nf,'(a256)') cbuff
    read(cbuff,*,iostat=ier) qf,rf,qm,qc,beta, &
         qbtp(1),qbtp(2),qbtp(3)
    if (ier.ne.0) then
       read(cbuff,*) qf,rf,qm,qc,beta
       qbtp(1) = 0.0d0
       qbtp(2) = qm
       qbtp(3) = qm
    end if

    if (qc.gt.qf) then
       qc=qf
    end if
    if (qbtp(1).gt.0.0d0 .and. qbtp(2).gt.qm) then
       if (mssg.gt.-1) write(6,'(1x,a)') 'Qbtp must smaller than Qm.'
       stop
    end if
    read(nf,*) nkd,nsi
    allocate(asi(3,nsi),kd(nsi),mkd(nsi))

    if (ifcg.ne.0 .and. ifcg.ne.1) then
       if (mssg.gt.-1) write(6,*)'Error ifcg=',ifcg
       stop 'RDDATA1'
    end if
    !
    !     skip removed real space projection data
    !
    read(nf,*)
    read(nf,*)
    !
    ! atmvbc
    do it=1,nsi
       read(nf,'(a256)') cbuff
       read(cbuff,*,iostat=ier) &
            kd(it),asi(1,it),asi(2,it),asi(3,it),mkd(it)
       if (ier.ne.0 .and. ifcg.eq.0) then
          read(cbuff,*) kd(it),asi(1,it),asi(2,it),asi(3,it)
          mkd(it) = 0
       else if (ier.ne.0) then
          if (mssg.gt.-1) write(6,'(1x,a,i4)') &
               'error in atomic position data: it = ', it
          stop
       end if
       if (kd(it).le.0) then
          if (mssg.gt.-1) write(6,'(1x,a,i4)') &
               'kd <= 0 for it = ',it
          stop
       end if
       if (ifcg.eq.1 .and. mkd(it).le.0) then
          if (mssg.gt.-1) write(6,'(1x,a,i4)') &
               'mkd <= 0 for it = ',it
          stop
       end if
    end do

    kdmax=0
    do it=1,nsi
       kdmax=max(kdmax,kd(it))
    end do
    if (kdmax .gt. nkd) then
       if (mssg.gt.-1) write(6,*) 'Error: max(kd) > nkd'
       stop
    end if

    read(nf,*) nrx,nry,nrz
    read(nf,*) ngx,ngy,ngz

    read(nf,*) ndx,ndy,ndz
    ! for calculation of charged state
    read(nf,30) cinput
    csave=cinput
30  format(a80)
    !     read nk
    call mvint(cinput,80,nk,ier)
    if (ier.ne.0) goto 35
    !     read nw
    call mvint(cinput,80,nw,ier)
    if (ier.ne.0) goto 35
    !     read nb1
    call mvint(cinput,80,nb1,ier)
    if (ier.ne.0) goto 35
    !     read nb2
    call mvint(cinput,80,nb2,ier)
    if (ier.ne.0) goto 35
    ! Error trap
35  continue
    if (ier.ne.0) then
       if (mssg.gt.-1) then
          write(6,*)'READ ERROR!: IER=',ier
          write(6,38)cinput
38        format(' WRONG STRINGS=',a80)
          write(6,39)csave
39        format(' INPUT    LINE=',a80)
       end if
       stop 'rddata2'
    end if
    !     read znext
    call mvdbl(cinput,80,znext,ier)
    ! branch for old version
    if (ier.ne.0) then
       znext=0.0d0
       dspin=0.0d0
    else
       !     read dspin
       call mvdbl(cinput,80,dspin,ier)
       ! branch for old version
       if (ier.ne.0) then
          dspin=0.0d0
       end if
    end if
    !

    nband = nw

    if (nb2.gt.nw) then
       write(6,*) 'error: nb2 > nw. nb2, nw = ',nb2,nw
       stop 'RDDATA'
    end if
    if (nb1.gt.nb2) then
       write(6,*) 'error: nb1 > nb2. nb1, nb2 = ',nb1,nb2
       stop 'RDDATA'
    end if
    !
    ! ewalds in vbtest, ewald0 in cgmain
    read(nf,*) 
    read(nf,*) 
    !
    ! meshk2 in meshk
    !  m1, m2, m3  -> mmm(?,1,?)
    !  mm1,mm2,mm3 -> mmm(?,2,?)
    nsk=1
    allocate(tmmm(3,2,nask))
500 continue
    read(nf,*) (tmmm(i,1,nsk),i=1,3)
    if(tmmm(1,1,nsk).eq.0) go to 501
    read(nf,*) (tmmm(i,2,nsk),i=1,3)
    if (nsk.ge.nask) then
       if (mssg.gt.-1) write(6,*) &
            'NASK is too SMALL!!! nask',nask
       stop 'RDDATA'
    end if
    nsk=nsk+1
    go to 500
501 continue
    nsk=nsk-1
    allocate(mmm(3,2,nsk))
    mmm(:,:,1:nsk) = tmmm(:,:,1:nsk)
    ! nkrchg
    !     -- read line and check number of data
    read(nf,'(A)') cinput
    call getint(cinput,80,idat,3)
    !
    !
    ! CG-DATA READING
    if (ifcg.eq.1) then
       read(nf,'(A)') cinput
       ier = -2
       j = nopt+1
       do while (ier.ne.0)
          j = j - 1
          read(cinput,*,iostat=ier) (iopt(i),i=1,j)
          if (j .eq. 0) then
             if (mssg.gt.-1) write(6,*) 'error in iopt'
             stop
          end if
       end do
       iopt(j+1:nopt) = 0

       read(nf,*)nmkd
       allocate(tim(3,3,nmkd))

       do imkd=1,nmkd
          do i=1,3
             read(nf,*)(tim(j,i,imkd),j=1,3)
          end do
       end do
       read(nf,*)eps,eepsa,feps,ekbt
       read(nf,*)decr,okatom,uptime
       read(nf,*)niter0,niter1,itsb,ndiag0,ndiag1
       read(nf,*)ncycl,nrfr,most
    end if

    ios = -1
    flg = .true.
    !
    ! expects we can rewind nfin.
    do while (flg)
       read(nf,'(a)',END=600) cbuff
       if (trim(cbuff).eq.'# exch data') then
          flg = .false.
       end if
    end do

    read(nf,*,iostat=ios) qexat(1), qexat(2)
600 continue

    if (ios.ne.0) then
       qexat = -1.0d0
    end if
    !
    return
  end subroutine rddata
end module subr_rdolddata

module subr_writeparam
  character(len=*),parameter:: magic_inputparam = '# main data'
contains
  !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
  subroutine write_tappinput(ax,aa,nspin,ismode,qf,qm,qc,beta, &
       qbtp,qexat,nkd,nsi,nw,znext,dspin,iopt,eps,eeps,ekbt, &
       uptime,niter0,niter1,itsb,ndiag0,ndiag1, &
       qbsp,nbsf,fwqcom,xctp,osqnrm,mssg,info)
    !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
    use xcf_types
    implicit none

    real(8), intent(in)  :: ax
    real(8), dimension(3,3), intent(in) :: aa
    integer, intent(in) :: nspin, ismode
    real(8), intent(in) :: qf, qm, qc, beta, qbtp(3), qexat(2)
    integer, intent(in) :: nkd, nsi
    integer, intent(in) :: nw
    real(8), intent(in) :: znext, dspin
    integer, dimension(5), intent(in) :: iopt
    real(8), intent(in) :: eps, eeps, ekbt
    real(8), intent(in) :: uptime
    integer, intent(in) :: niter0, niter1, itsb, ndiag0, ndiag1

    real(8) :: qbsp, fwqcom
    integer :: nbsf, xctp, osqnrm

    integer,intent(in) :: mssg
    integer :: info

    real(8) :: lattice_factor
    real(8) :: lattice_list(9)

    integer :: number_spin, spin_mode

    real(8) :: cutoff_local_potential, cutoff_wave_function
    real(8) :: cutoff_uspp_q, xtrap_beta
    real(8) :: cutoff_btp_A, cutoff_btp_gc, cutoff_btp_sigma

    integer :: number_element, number_atom
    integer :: number_band
    real(8) :: extra_charge, diff_spin

    integer :: number_xtrap_stage, initial_wfn, initial_lpt, store_wfn, &
         chain_calc, flag_precond_lpt

    real(8) :: scf_converge, scf_converge_energy, elec_kbt
    real(8) :: control_uptime
    integer :: scf_number_iter_1st, scf_number_iter
    integer :: davidson_flag
    integer :: davidson_number_diag_1st, davidson_number_diag

    real(8) :: cutoff_bspl_fit, control_q_han_win_fac
    integer :: control_nbsf
    character(len=64):: xc_type

    real(8) :: cutoff_exch_att_rc, cutoff_exch_att_rd
    real(8) :: scf_threshold_hybrid
    integer :: compat_old_squ_norm

    namelist /tappinput/ lattice_factor, &
         lattice_list, &
         number_spin, spin_mode, &
         cutoff_local_potential, cutoff_wave_function, &
         cutoff_uspp_q, xtrap_beta, &
         cutoff_btp_A, cutoff_btp_gc, cutoff_btp_sigma, &
         number_element, number_atom, number_band, &
         extra_charge, diff_spin, elec_kbt, &
         number_xtrap_stage, initial_wfn, initial_lpt, &
         store_wfn, chain_calc, flag_precond_lpt, &
         scf_converge, scf_converge_energy, &
         scf_number_iter_1st, scf_number_iter, &
         davidson_flag, &
         davidson_number_diag_1st, davidson_number_diag, &
         control_uptime, &
         cutoff_bspl_fit, control_q_han_win_fac, control_nbsf, &
         xc_type, &
         cutoff_exch_att_rc, cutoff_exch_att_rd, scf_threshold_hybrid, &
         compat_old_squ_norm

    ! substitute vars

    lattice_factor = ax

    lattice_list(1) = aa(1,1)
    lattice_list(2) = aa(2,1)
    lattice_list(3) = aa(3,1)
    lattice_list(4) = aa(1,2)
    lattice_list(5) = aa(2,2)
    lattice_list(6) = aa(3,2)
    lattice_list(7) = aa(1,3)
    lattice_list(8) = aa(2,3)
    lattice_list(9) = aa(3,3)
    !  aa = ax*aa

    number_spin = nspin
    spin_mode = ismode

    cutoff_wave_function = qm
    cutoff_local_potential = qf
    cutoff_uspp_q = qc
    xtrap_beta = beta

    cutoff_btp_A = qbtp(1)
    cutoff_btp_gc = qbtp(2)
    cutoff_btp_sigma = qbtp(3) 

    number_element = nkd
    number_atom = nsi

    number_band = nw

    extra_charge = znext
    diff_spin = dspin

    number_xtrap_stage = iopt(1)
    initial_wfn = iopt(2)
    initial_lpt = iopt(3)
    store_wfn = iopt(4)
    chain_calc = iopt(5)
    flag_precond_lpt = iopt(6)

    control_uptime = uptime

    elec_kbt = ekbt

    scf_converge = eps
    scf_converge_energy = eeps
    scf_number_iter_1st = niter0
    scf_number_iter = niter1
    davidson_flag = itsb
    davidson_number_diag_1st = ndiag0
    davidson_number_diag = ndiag1

    cutoff_bspl_fit = qbsp
    control_nbsf = nbsf
    control_q_han_win_fac = fwqcom 

    if (xctp.eq.xcf_pbe) then
       xc_type = xcf_pbe_name
    else if (xctp.eq.xcf_pbesol) then
       xc_type = xcf_pbesol_name
    else if (xctp.eq.xcf_capz) then
       xc_type = xcf_capz_name
    else if (xctp.eq.xcf_pw91) then
       xc_type = xcf_pw91_name
    else if (xctp.eq.xcf_ldapw92) then
       xc_type = xcf_ldapw92_name
    else if (xctp.eq.xcf_hartree_fock) then
       xc_type = xcf_hartree_fock_name
    else if (xctp.eq.xcf_pbe0) then
       xc_type = xcf_pbe0_name
    else if (xctp.eq.xcf_b3lyp) then
       xc_type = xcf_b3lyp_name
    end if
    cutoff_exch_att_rc = qexat(1)
    cutoff_exch_att_rd = qexat(2)

    scf_threshold_hybrid = 1.0d-8
    compat_old_squ_norm = osqnrm

    if (mssg.gt.-1) then
       write(6,'(a)') magic_inputparam
       write(6,tappinput)
    end if

    return

  end subroutine write_tappinput
end module subr_writeparam

module subr_writestropt
  character(len=*),parameter:: magic_tappstropt = '# struct_opt data'
contains
  subroutine write_tappstropt(ax,nsi,eepsa,feps, &
       decr,okatom,ncycl,nrfr,most,syspext,stscl,mssg,info)
    !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
    use xcf_types
    implicit none

    integer, intent(in) :: nsi
    real(8), intent(in) :: ax
    real(8), intent(in) :: eepsa, feps
    real(8), intent(in) :: decr, okatom
    integer, intent(in) :: ncycl, nrfr, most

    real(8) :: syspext
    real(8), dimension(6) :: stscl

    integer,intent(in) :: mssg
    integer :: info

    real(8) :: search_1d_fratio, displacement_max
    real(8) :: converge_energy, converge_force
    integer :: number_cycle, refresh_cycle
    integer :: search_1d_max_step

    real(8) :: extern_pressure
    real(8) :: stress_scale(6)

    namelist /struct_opt/ &
         converge_energy, converge_force, &
         search_1d_fratio, &
         displacement_max, &
         number_cycle, refresh_cycle, &
         search_1d_max_step, &
         extern_pressure, stress_scale

    ! substitute vars

    converge_energy = eepsa
    converge_force = feps
    search_1d_fratio = decr
    displacement_max = okatom

    number_cycle = ncycl
    refresh_cycle = nrfr
    search_1d_max_step = most

    extern_pressure = syspext
    stress_scale = stscl(:)

    if (mssg.gt.-1) then
       write(6,'(a)') magic_tappstropt
       write(6,struct_opt)
    end if

    return
  end subroutine write_tappstropt
end module subr_writestropt

module subr_writesym
  character(len=*),parameter:: magic_tappsym = '# symmetry data'
contains
  !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
  subroutine write_tappsym(ng,nsv,nnp,rg,pg,nsymq,mssg,info)
    !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
    implicit none

    integer,intent(in) :: nsymq

    integer :: ng, nsv, nnp
    integer :: rg(3,3,nsymq), pg(3,nsymq)
    integer,intent(in) :: mssg
    integer :: info

    integer :: i, j
    integer :: ig

    character(len=32):: symmetry_format
    integer :: number_sym_op, has_inversion, denom_trans

    namelist /symmetry/ symmetry_format, &
         number_sym_op, has_inversion, denom_trans

    symmetry_format = 'reciprocal'
    number_sym_op = ng
    has_inversion = nsv
    denom_trans = nnp

    if (mssg.gt.-1) then
       write(6,'(a)') magic_tappsym
       write(6,symmetry)
       write(6,'(3(2x,3(1x,i2)),3x,3(1x,i2),a)') &
            ((rg(i,j,1),i=1,3),j=1,3),(pg(i,1),i=1,3), ' ! rg(3,3), pg(3)'
       do ig=2,number_sym_op
          write(6,'(3(2x,3(1x,i2)),3x,3(1x,i2))') &
               ((rg(i,j,ig),i=1,3),j=1,3),(pg(i,ig),i=1,3)
       end do
    end if


  end subroutine write_tappsym
end module subr_writesym

module subr_writeatom
  character(len=*),parameter:: magic_tappatom = '# atom data'
contains
  !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
  subroutine write_tappatom(nkd,nsi,kd,asi,mssg,info)
    !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
    implicit none

    integer, intent(in) :: nkd
    integer, intent(in) :: nsi

    integer, dimension(:), pointer :: kd
    real(8), dimension(:,:), pointer :: asi

    integer, intent(in) :: mssg
    integer :: info

    integer :: it,ikd

    if (mssg.gt.-1) then
       write(6,'(a)') magic_tappatom
       write(6,'(1x,f13.9,1x,f13.9,a)') 0.0, 0.0, ' ! zo, zn'
       do ikd=2,nkd
          write(6,'(1x,f13.9,1x,f13.9)') 0.0, 0.0
       end do
       write(6,'(1x,i5,3(1x,e18.11),a)') kd(1),asi(1,1),asi(2,1),asi(3,1), &
            ' ! atom_kind, pos_a, pos_b, pos_c (in lattice coordiate)'
       do it=2,nsi
          write(6,'(1x,i5,3(1x,e18.11))') kd(it),asi(1,it),asi(2,it),asi(3,it)
       end do
    end if

  end subroutine write_tappatom
end module subr_writeatom

module subr_writestroptconstr
  character(len=*),parameter:: magic_tappstroptconstr = '# str_opt_constr data'
contains
  !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
  subroutine write_tappstroptconstr(nmkd,tim,nsi,mkd,mssg,info)
    !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
    implicit none

    integer, intent(in) :: nsi

    integer :: nmkd
    real(8), dimension(:,:,:), pointer :: tim
    integer,pointer:: mkd(:)

    integer, intent(in) :: mssg
    integer :: info

    integer :: i, j, it
    integer :: imkd, nset, nmsi
    integer :: tatm(nsi)
    integer :: dnmkd

    if (tim(1,1,1).eq.1.0d0.and.tim(1,2,1).eq.0.0d0.and.tim(1,3,1).eq.0.0d0 &
   .and.tim(2,1,1).eq.0.0d0.and.tim(2,2,1).eq.1.0d0.and.tim(2,3,1).eq.0.0d0 &
   .and.tim(3,1,1).eq.0.0d0.and.tim(3,2,1).eq.0.0d0.and.tim(3,3,1).eq.1.0d0) then
       dnmkd = 0
    else
       dnmkd = 1
    end if

    if (mssg.gt.-1) then
       write(6,'(a)') magic_tappstroptconstr
       write(6,'(1x,i3)') nmkd + dnmkd
       do imkd = 2-dnmkd, nmkd
          do i = 1, 3
             write(6,'(3(1x,e18.11))') (tim(j,i,imkd),j=1,3)
          end do
       end do

       nset = 0
       do imkd=2-dnmkd,nmkd
          nmsi = 0
          do it = 1, nsi
             if (mkd(it).eq.imkd) nmsi = nmsi + 1
          end do
          if (nmsi.gt.0) nset = nset + 1
       end do
       write(6,'(1x,i5)') nset

       do imkd=2-dnmkd,nmkd
          nmsi = 0
          do it = 1, nsi
             if (mkd(it).eq.imkd) nmsi = nmsi + 1
          end do
          if (nmsi.gt.0) then
             write(6,'(1x,i5,1x,i5)') imkd+dnmkd, nmsi
             do it = 1, nsi
                if (mkd(it).eq.imkd) then
                   write(6,'(1x,i5)',advance='no') it
                end if
             end do
             write(6,'(/)',advance='no')
          end if
       end do
    end if

  end subroutine write_tappstroptconstr
end module subr_writestroptconstr

module subr_writekpoints
  character(len=*),parameter:: magic_tappkpoints = '# k-points data'
contains
  !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
  subroutine write_tappkpoints(nw,nb1,nb2,rf, &
       ndx,ndy,ndz,nk,nsk,mmm,idat,mssg,info)
    !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
    implicit none

    integer, intent(in) :: nw

    integer :: nb1, nb2
    real(kind=8):: rf
    integer :: ndx, ndy, ndz
    integer :: nk

    integer :: nsk
    integer, dimension(:,:,:), pointer :: mmm
    integer :: idat(3)

    integer, intent(in) :: mssg
    integer :: info

    integer :: i, j
    integer :: insk

    character(len=48) :: dos_mode
    real(kind=8):: cutoff_dos_cos
    integer :: dos_band_lower, dos_band_upper
    integer :: dos_mesh(3)
    integer :: bz_mesh
    integer :: bz_number_tile
    integer :: rmesh_number_shell
    integer :: rmesh_range(3)

    namelist /smpl_kpt/ dos_mode, dos_band_lower, dos_band_upper, &
         dos_mesh, bz_mesh, bz_number_tile, cutoff_dos_cos, &
         rmesh_number_shell, rmesh_range

    if (ndx.eq.0 .and. ndy.eq.0 .and. ndz.eq.0) then
       dos_mode = 'METHFESSEL_PAXTON'
    else if (ndx.lt.0 .and. ndy.lt.0 .and. ndz .lt.0)  then
       dos_mode = 'FERMI'
    else
       dos_mode = 'COS'
    end if
    cutoff_dos_cos = rf 
    dos_band_lower = nb1
    dos_band_upper = nb2 
    dos_mesh(1) = ndx 
    dos_mesh(2) = ndy
    dos_mesh(3) = ndz
    bz_mesh = nk
    bz_number_tile = nsk
    rmesh_number_shell = 0
    rmesh_range = 0
    if (nsk.ge.2) then
       if (idat(2).eq.0 .and. idat(3).eq.0) then
          rmesh_number_shell = idat(1)
       else
          rmesh_range = idat
       end if
    end if

    if (mssg.gt.-1) then
       write(6,'(a)') magic_tappkpoints
       write(6,smpl_kpt)

       do insk = 1, nsk
          do j = 1, 2
             write(6,'(3(1x,i5))')(mmm(i,j,insk),i=1,3)
          end do
       end do
    end if

    return
  end subroutine write_tappkpoints
end module subr_writekpoints

module subr_writemoldyn
  character(len=*),parameter:: magic_tappmoldyn = '# md data'
contains
  subroutine write_tappmd(mdmode,deltm,imdstp,emdstp,imtrw, &
       nkd,mass,nsi,cavl,syskbt,syspext,va0,sysvol, &
       mdparam,mdstat,msgcycl,mssg,info)
    !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
    implicit none

    integer, intent(in) :: nkd, nsi
    real(8), intent(in) :: va0
    character(len=16):: mdmode
    integer, intent(in) :: imdstp,emdstp,imtrw,msgcycl
    real(8),intent(in) :: mass(:),cavl(:,:)
    real(8),intent(in) :: deltm,syskbt,syspext,sysvol
    ! real(8):: mdparam(num_mdparam), mdstat(num_mdstat)
    real(8):: mdparam(5),mdstat(6)

    integer,intent(in) :: mssg
    integer :: info

    real(8):: delta_time
    integer:: init_md_step, end_md_step, mode_xtrap_rho_wfn
    integer:: message_cycle
    real(8):: system_volume, system_kbt, system_pressure
    real(8):: stern_omega_zeta, stern_omega_eta
    real(8):: stern_zeta, stern_eta, stern_sigma
    integer:: abinitio_cycle
    real(8):: wang_landau_update_factor
    integer:: wang_landau_weight_cycle, wang_landau_factor_cycle

    integer:: ikd, it

    namelist /mol_dyn/ &
         mdmode, delta_time, init_md_step, end_md_step, &
         mode_xtrap_rho_wfn, &
         message_cycle, &
         system_volume, system_kbt, system_pressure, &
         stern_omega_zeta, stern_omega_eta, &
         stern_zeta, stern_eta, stern_sigma, &
         abinitio_cycle, &
         wang_landau_update_factor, &
         wang_landau_weight_cycle, &
         wang_landau_factor_cycle
         
    ! substitute vars

    delta_time = deltm
    init_md_step = imdstp
    end_md_step = emdstp
    mode_xtrap_rho_wfn = imtrw
    message_cycle = msgcycl
    system_volume = sysvol
    system_kbt = syskbt
    system_pressure = syspext
    stern_omega_zeta = mdparam(1)
    stern_omega_eta = mdparam(2)
    stern_zeta = mdstat(1)
    stern_eta = mdstat(2)
    stern_sigma = mdstat(3)
    abinitio_cycle = mdparam(3)
    wang_landau_update_factor = mdstat(6)
    wang_landau_weight_cycle = mdparam(4)
    wang_landau_factor_cycle = mdparam(5)

    if (mssg.gt.-1) then
       write(6,'(a)') magic_tappmoldyn
       write(6,mol_dyn)
       if (mdmode .ne. 'SMPL') then
          write(6,'(1x,e18.11,a)') mass(1), ' ! mass in a.m.u.'
          do ikd=2,nkd
             write(6,'(1x,e18.11)') mass(ikd)
          end do
          write(6,'(3(1x,e18.11),a)') cavl(1,1),cavl(2,1),cavl(3,1), ' ! velocity in Cartesian coordinate'
          do it=2,nsi
             write(6,'(3(1x,e18.11))') cavl(1,it),cavl(2,it),cavl(3,it)
          end do
       end if
    end if

    return
  end subroutine write_tappmd
end module subr_writemoldyn

module subr_writepef
  character(len=*),parameter:: magic_tapppef = '# trace band data'
  integer,parameter:: nkptl = 6
contains
  !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
  subroutine write_tapppef(nbk,nkpt,ak,nkfi,nw,nb2,itsb,ndiag,deps, &
          ifbunp,ifrho,nbba1,nbba2,iaxis,ndiv,rzero, &
          rmin,rmax,nsph,mssg,info)
    !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
    implicit none

    integer, intent(in) :: mssg
    integer,intent(out) :: info

    integer,intent(in):: ifbunp,ifrho,nbk
    integer,intent(in):: nkfi(:)
    real(kind=8),intent(in):: ak(:,:)
    real(kind=8),intent(in):: deps
    character(len=nkptl):: nkpt(:)
    integer,intent(in):: ndiv(:),iaxis(:)
    real(kind=8):: rzero(:,:),rmin(:),rmax(:)
    integer:: nw,nb2
    integer,intent(in):: itsb,ndiag,nbba1,nbba2,nsph

    character(len=32):: distrib_mode
    integer:: output_charge, output_wave_function
    integer:: davidson_flag, davidson_number_diag
    real(kind=8):: diag_converge
    integer:: distrib_band_lower, distrib_band_upper
    integer:: distrib_number_sphere, distrib_number_plate
    integer:: number_band, number_band_traced, number_trace_block

    integer:: i,j,is

    namelist /trace_band/ distrib_mode, output_charge, output_wave_function, &
         davidson_flag, davidson_number_diag, diag_converge, &
         distrib_band_lower, distrib_band_upper, &
         distrib_number_sphere, distrib_number_plate, &
         number_band, number_band_traced, number_trace_block

    ! substitute vars
    
    distrib_number_plate = 0
    distrib_number_sphere = 0
    if (ifbunp .eq. 0) then
       distrib_mode = 'none'
    else if (ifbunp .eq. 1) then
       distrib_mode = 'plate'
       distrib_number_plate = nsph
    else if (ifbunp .eq. 2) then
       distrib_mode = 'sphere'
       distrib_number_sphere = nsph
    end if
    number_trace_block = nbk
    output_charge = 0
    output_wave_function = 0
    if (ifrho .eq. 1) output_charge = 1
    if (ifrho .eq. 2) output_wave_function = 1
    davidson_flag = itsb
    davidson_number_diag = ndiag
    diag_converge = deps
    distrib_band_lower = nbba1
    distrib_band_upper = nbba2
    number_band = nw
    number_band_traced = nb2

    ! print input

    if (mssg.gt.-1) then
       write(6,'(a)') magic_tapppef
       write(6, trace_band)

       write(6,'(4x,a)',advance='no') trim(nkpt(1))
       do i=2,number_trace_block
          write(6,'(6x,a)',advance='no') trim(nkpt(i))
       end do
       write(6,'(6x,a)') trim(nkpt(number_trace_block+1))

       do i=1,3
          write(6,'(1x)',advance='no')
          do j=1,number_trace_block
             write(6,'(1x,f11.8)',advance='no') ak(i,j)
          end do
          write(6,'(1x,f11.8,'' ! ak('',i1,'')'')') ak(i,number_trace_block+1),i
       end do

       write(6,'(3x)',advance='no')
       do i=1,number_trace_block-1
          write(6,'(4x,i3)',advance='no') nkfi(i)
       end do
       write(6,'(4x,i3)') nkfi(number_trace_block)

       if (trim(distrib_mode) .eq. 'sphere') then
          write(6,'(5(1x,e18.11),1x,i5,a)') &
               (rzero(i,1),i=1,3),rmin(1),rmax(1),ndiv(1), &
               ' ! rzero(3),rmin,rmax,ndiv'
          do is=2,distrib_number_sphere
             write(6,'(5(1x,e18.11),1x,i5,a)') &
                  (rzero(i,is),i=1,3),rmin(is),rmax(is),ndiv(is)
          end do
       else if (trim(distrib_mode) .eq. 'plate') then
          write(6,'(1x,i5,2(1x,e18.11),1x,i5,a)') &
               iaxis(1),rmin(1),rmax(1),ndiv(1), &
               ' ! iaxis,rmin,rmax,ndiv'
          do is=2,distrib_number_plate
             write(6,'(1x,i5,2(1x,e18.11),1x,i5)') &
                  iaxis(is),rmin(is),rmax(is),ndiv(is)
          end do
       end if
    end if

    return

100 continue
    write(6,'(A)')'error occurs @ reading namelist : trace_band'
    info = 1
    return
  end subroutine write_tapppef
end module subr_writepef

module subr_writewfn2chg
  character(len=*),parameter:: magic_tappwfn2chg = '# inspect wfn data'
contains
  !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
  subroutine write_tappwfn2chg(nw,nsi,ifbunp,ifrho,nbba1,nbba2, &
       iaxis,ndiv,rzero,rmin,rmax,nsph,itwav,mssg,info)
    !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
    implicit none

    integer,intent(in) :: nw,nsi,mssg
    integer :: info

    integer,intent(in):: ifbunp,ifrho
    integer,intent(in):: ndiv(:),iaxis(:)
    real(kind=8):: rzero(:,:),rmin(:),rmax(:)
    integer,intent(in):: nbba1,nbba2,nsph,itwav

    character(len=32):: distrib_mode
    integer:: output_charge
    integer:: distrib_band_lower, distrib_band_upper
    integer:: distrib_number_sphere, distrib_number_plate
    integer:: pdos_target_atom

    integer:: i,j,is

    namelist /inspect_wfn/ distrib_mode, output_charge, &
         distrib_band_lower, distrib_band_upper, &
         distrib_number_sphere, distrib_number_plate, &
         pdos_target_atom

    ! substitute vars
    
    distrib_number_plate = 0
    distrib_number_sphere = 0
    if (ifbunp .eq. 0) then
       distrib_mode = 'none'
    else if (ifbunp .eq. 1) then
       distrib_mode = 'plate'
       distrib_number_plate = nsph
    else if (ifbunp .eq. 2) then
       distrib_mode = 'sphere'
       distrib_number_sphere = nsph
    else if (ifbunp .eq. 3) then
       distrib_mode = 'pdos'
    end if

    output_charge = 0
    if (ifrho .eq. 1) output_charge = 1

    distrib_band_lower = nbba1
    distrib_band_upper = nbba2
    pdos_target_atom = itwav

    ! print input

    if (mssg.gt.-1) then
       write(6,'(a)') magic_tappwfn2chg
       write(6, inspect_wfn)

       if (trim(distrib_mode) .eq. 'sphere') then
          write(6,'(5(1x,e18.11),1x,i5,a)') &
               (rzero(i,1),i=1,3),rmin(1),rmax(1),ndiv(1), &
               ' ! rzero(3),rmin,rmax,ndiv'
          do is=2,distrib_number_sphere
             write(6,'(5(1x,e18.11),1x,i5,a)') &
                  (rzero(i,is),i=1,3),rmin(is),rmax(is),ndiv(is)
          end do
       else if (trim(distrib_mode) .eq. 'plate') then
          write(6,'(1x,i5,2(1x,e18.11),1x,i5,a)') &
               iaxis(1),rmin(1),rmax(1),ndiv(1), &
               ' ! iaxis,rmin,rmax,ndiv'
          do is=2,distrib_number_plate
             write(6,'(1x,i5,2(1x,e18.11),1x,i5)') &
                  iaxis(is),rmin(is),rmax(is),ndiv(is)
          end do
       end if
    end if

    return
  end subroutine write_tappwfn2chg
end module subr_writewfn2chg

module subr_writestm
  character(len=*),parameter:: magic_tappstm = '# stm data'
contains
  subroutine write_tappstm(nbias,eferm,vs,mssg,info)
    !----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+
    use xcf_types
    implicit none

    integer, intent(in) :: nbias
    real(8), intent(in) :: eferm
    real(8), intent(in) :: vs(:)

    integer,intent(in) :: mssg
    integer :: info

    integer :: number_bias
    real(8) :: stm_fermi_energy

    integer:: i

    namelist /stminput/ number_bias, stm_fermi_energy

    ! substitute vars
    
    number_bias = nbias
    stm_fermi_energy = eferm

    if (mssg.gt.-1) then
       write(6,'(a)') magic_tappstm
       write(6,stminput)
       do i=1,number_bias
          write(6,'(1x,e18.11)') vs(i)
       end do
    end if

    return

  end subroutine write_tappstm
end module subr_writestm

program old2new
  use util
  use iounit
  use types
  use subr_rdolddata

  use subr_writeparam
  use subr_writestropt
  use subr_writesym
  use subr_writeatom
  use subr_writestroptconstr
  use subr_writekpoints
  use subr_writemoldyn
  use subr_writepef
  use subr_writewfn2chg
  use subr_writestm
  implicit none
  !
#include "config90.h"
  real(kind=8):: bb0(3,3),bx,va0,vb0
  integer:: nhx,nhy,nhz,nrxyz,ntt,nks,nspin,nkmesh
  integer:: nrcell,ngxyz,nvx,nvy,nvz,nvxyz
  integer:: nwx,nwy,nwz

  integer:: nkr,nkfxa,nng
  !
  integer:: nkc
  !
  real(kind=8):: aa0(3,3),ax
  integer:: nsi,nkd
  integer:: nband,nw,nb1,nb2,nk
  real(kind=8),pointer:: asi(:,:)
  real(kind=8):: znext,dspin
  integer,pointer:: kd(:)
  integer:: rg(3,3,nsymq),pg(3,nsymq),ng,nsv,nnp
  integer:: iopt(nopt)
  integer,pointer:: mkd(:)
  real(kind=8),pointer:: tim(:,:,:)
  real(kind=8):: qf,rf,qm,qc,qbtp(3),qexat(2)
  real(kind=8):: beta,eps,eepsa,feps,ekbt,decr,okatom,uptime,eeps
  integer:: nmkd,niter0,niter1,itsb,ndiag0,ndiag1,nrfr,most,ncycl
  integer:: ismode
  integer:: nsk,idat(3)
  integer,pointer:: mmm(:,:,:)
  integer:: nrx,nry,nrz,ndx,ndy,ndz,ngx,ngy,ngz
  !
  real(kind=8):: qwf
  !
  integer:: it, i
  integer:: ik,is
  real(kind=8):: clk

  real(kind=8) :: qbsp, fwqcom
  integer :: nbsf, xctp

  real(kind=8):: axn,syspext,stscl(6),aa(3,3),bb(3,3),va

  integer:: nwp,nb2p,ifbunp,ifrho
  integer:: nbk,nsph,nbba1,nbba2
  real(kind=8),allocatable:: ak(:,:)
  real(kind=8),allocatable:: rzero(:,:),rmin(:),rmax(:)
  integer,allocatable:: ndiv(:),iaxis(:),nkfi(:)
  character(len=nkptl),allocatable:: nkpt(:)
  real(kind=8):: deps
  integer:: itsbp,ndiag0p

  integer:: ifbunpw,ifrhow
  integer:: nsphw,nbba1w,nbba2w
  real(kind=8),allocatable:: rzerow(:,:),rminw(:),rmaxw(:)
  integer,allocatable:: ndivw(:),iaxisw(:)
  integer:: itwav

  integer:: nbiasq
  parameter (nbiasq=16)
  real(kind=8):: eferm,vs(nbiasq)
  integer:: nbias

  character(len=16):: mdmode, tmpmode
  real(kind=8):: deltm
  integer:: imdstp, emdstp, imtrw
  real(kind=8),allocatable:: mass(:),casi(:,:),cavl(:,:)
  real(kind=8):: syskbt,syspextmd,sysvol
  ! real(kind=8):: mdstat(num_mdstat),mdparam(num_mdparam)
  real(kind=8):: mdstat(6),mdparam(5)
  real(kind=8),allocatable:: mdastat(:,:,:)
  integer:: msgcycl

  integer:: ifpef,ifwfn2chg,ifstm,ifmd,mssg,info
  integer:: osqnrm

  integer:: ic
  character(len=256):: ifname, argv(2)
  !
  mssg = 0

  if (iargc().lt.1) then
     write(6,*) 'usage: inputconv [ [-tapp3] filename]'
     stop
  end if
  osqnrm = 0
  ic = 1
  if (iargc().eq.2) then
     call getarg(ic,argv(ic))
     if (trim(argv(ic)).eq.'-tapp3') then
        osqnrm = 1
     else
        write(6,*) 'usage: inputconv [[-tapp3] filename]'
        stop
     end if
     ic = ic + 1
  end if
  call getarg(ic, argv(ic))
  ifname = argv(ic)
  open(NFINPUT, file=ifname, status='old', action='read', form='formatted', &
       iostat=info)
  if (info.ne.0) then
     write(6,*) 'usage: inputconv [[-tapp3] filename]'
     stop
  end if

  call rddata(ax,bx,aa0,bb0,va0,vb0,ng,nsv,nnp,rg,pg,nsymq &
       ,qf,rf,qm,qc,beta,qbtp,qexat &
       ,nkd,nsi,kd,asi,mkd &
       ,nband,nspin,znext,dspin &
       ,nrx,nry,nrz,nrxyz,ntt,ngx,ngy,ngz,ngxyz,nhx,nhy,nhz &
       ,qwf,nwx,nwy,nwz &
       ,ndx,ndy,ndz,nk,nw,nb1,nb2,mmm,nsk &
       ,idat,iopt,nopt,ismode,nmkd,tim,eps,eepsa,feps,ekbt &
       ,niter0,niter1,itsb,ndiag0,ndiag1,ncycl,nrfr,most &
       ,decr,okatom,uptime,1,NFINPUT,mssg)

  eeps = eepsa

  call rdipdat(NFINPUT,qf,qbsp,nbsf,fwqcom,xctp,mssg)

  call rdcgdat(NFINPUT,axn,syspext,stscl,mssg)

  call rdpef(nbk,nwp,nb2p,itsbp,ndiag0p,deps &
       ,ifbunp,ifrho,nbba1,nbba2,nsph,NFINPUT,mssg,ifpef)

  call rdwfn2chg(NFINPUT,nw,ifbunpw,ifrhow,nbba1w,nbba2w &
       ,nsphw,itwav,nsi,mssg,ifwfn2chg)

  call rdstm(NFINPUT,eferm,vs,nbiasq,nbias,ifstm)

  allocate(mass(nkd),casi(3,nsi),cavl(3,nsi),mdastat(3,nsi,1))

  call rdmddat(NFINPUT,mdmode,deltm,imdstp,emdstp,imtrw, &
       nkd,nsi,syskbt,syspextmd,va0,sysvol, &
       mdparam,mdstat,msgcycl,mssg,ifmd)

  call write_tappinput(ax,aa0,nspin,ismode,qf,qm,qc,beta, &
       qbtp,qexat,nkd,nsi,nw,znext,dspin,iopt,eps,eeps,ekbt, &
       uptime,niter0,niter1,itsb,ndiag0,ndiag1, &
       qbsp,nbsf,fwqcom,xctp,osqnrm,mssg,info)

  call write_tappsym(ng,nsv,nnp,rg,pg,nsymq,mssg,info)

  call write_tappatom(nkd,nsi,kd,asi,mssg,info)

  call write_tappkpoints(nw,nb1,nb2,rf,ndx,ndy,ndz,nk,nsk,mmm,idat,mssg,info)

  call write_tappstropt(axn,nsi,eepsa,feps, &
       decr,okatom,ncycl,nrfr,most,syspext,stscl,mssg,info)

  call write_tappstroptconstr(nmkd,tim,nsi,mkd,mssg,info)

  if (ifpef.eq.0) then
     call write_tapppef(nbk,nkpt,ak,nkfi,nwp,nb2p,itsbp,ndiag0p,deps, &
          ifbunp,ifrho,nbba1,nbba2,iaxis,ndiv,rzero, &
          rmin,rmax,nsph,mssg,info)
  end if
  if (ifwfn2chg.eq.0) then
     call write_tappwfn2chg(nw,nsi,ifbunpw,ifrhow,nbba1w,nbba2w, &
       iaxisw,ndivw,rzerow,rminw,rmaxw,nsphw,itwav,mssg,info)
  end if
  if (ifstm.eq.0) then
     call write_tappstm(nbias,eferm,vs,mssg,info)
  end if
  if (ifmd.eq.0) then
     call write_tappmd(mdmode,deltm,imdstp,emdstp,imtrw, &
       nkd,mass,nsi,cavl,syskbt,syspextmd,va0,sysvol, &
       mdparam,mdstat,msgcycl,mssg,info)
  end if
contains
  subroutine rdipdat(nfin,qf,qbsp,nbsf,fwqcom,xctp,mssg)
    use xcf_types
    implicit none
    integer,intent(in):: nfin, mssg
    integer:: nbsf
    real(kind=8),intent(in):: qf
    real(kind=8):: qbsp, fwqcom
    integer:: xctp

    character(len=*),parameter:: magic = '# inipot data'
    character(len=256):: buf
    logical:: flg
    integer:: ierr

    flg = .true.
    rewind(nfin)
    do while (flg)
       read(nfin,'(a)',END=999) buf
       if (trim(buf).eq.magic) then
          flg = .false.
       end if
    end do

    read(nfin,*) qbsp,nbsf
    if (qbsp .lt. 0.0d0) then
       qbsp = 1.5d0*qf
    else if (qbsp .lt. qf) then
       if (mssg.gt.0) write(6,'(1x,a)') 'Qbsp must be >= Qf'
       stop
    end if
    if (nbsf.lt.0) then
       nbsf = 2000
    else if (nbsf.eq.0) then
       if (mssg.gt.0) write(6,'(1x,a)') 'Nbsf must be > 0'
       stop
    end if

    read(nfin,*,IOSTAT=ierr) fwqcom
    if (ierr.ne.0 .or. fwqcom.lt.0.0d0) then
       fwqcom = -1.0d0
    else if (fwqcom .lt. 2.0d0) then
       if (mssg.gt.0) write(6,'(1x,a)') 'FwQcom must be >= 2.0d0'
       stop
    end if

    read(nfin,*,IOSTAT=ierr) buf
    if (ierr.ne.0) then
       write(6,'(1x,a)') 'default XC type'
       xctp = xcf_pbe
    else if (trim(buf).eq.xcf_pbe_name) then
       xctp = xcf_pbe
    else if (trim(buf).eq.xcf_pbesol_name) then
       xctp = xcf_pbesol
    else if (trim(buf).eq.xcf_capz_name) then
       xctp = xcf_capz
    else if (trim(buf).eq.xcf_pw91_name) then
       xctp = xcf_pw91
    else if (trim(buf).eq.xcf_ldapw92_name) then
       xctp = xcf_ldapw92
    else if (trim(buf).eq.xcf_hartree_fock_name) then
       xctp = xcf_hartree_fock
    else if (trim(buf).eq.xcf_pbe0_name) then
       xctp = xcf_pbe0
    else if (trim(buf).eq.xcf_b3lyp_name) then
       xctp = xcf_b3lyp
    else
       if (mssg.gt.0) write(6,'(1x,a)') 'Unknown XC type'
       stop
    end if

    return

999 continue

    qbsp = 1.5d0*qf
    nbsf = 2000
    fwqcom = -1.0d0
    xctp = xcf_pbe

    return
  end subroutine rdipdat

  subroutine rdcgdat(nfin,axn,syspext,stscl,mssg)
    implicit none
    real(kind=8):: ax,bx,aa(3,3),bb(3,3),va,syspext,stscl(6)
    integer,intent(in):: nfin,mssg

    character(len=*),parameter:: magic = '# cg data'
    character(len=256):: buf
    logical:: flg
    integer:: ios

    real(kind=8):: axn, sysscl

    rewind(nfin)

    syspext = 0.0d0
    stscl = 0.0d0
    flg = .true.
    do while (flg)
       read(nfin,'(a)',END=999) buf
       if (trim(buf).eq.magic) then
          flg = .false.
       end if
    end do

    read(nfin,*) axn

    read(nfin,'(a)',iostat=ios) buf
    if (ios.eq.0) then
       read(buf,*,iostat=ios) syspext,stscl(1),stscl(2),stscl(3), &
            stscl(4),stscl(5),stscl(6)
       if (ios.ne.0) then
          read(buf,*,iostat=ios) syspext,stscl(1)
          if (ios.eq.0) then
             stscl(2:6) = stscl(1)
          end if
       end if
    end if
    return

999 continue
    return
  end subroutine rdcgdat

  subroutine rdpef(nbk,nw,nb2,itsb,ndiag,eps &
       ,ifbunp,ifrho,nbba1,nbba2,nsph,nf,mssg,ierr)
    !
    !     rdpef -- read vbpef data from (nf) in addition to rddata
    !              1995.8.21 Y.Suwa
    !           -- modified to read distribution data
    !              1996.02.28 J.Yamauchi
    !     input file: following to the data for cgmian or vbtest,
    !     1st-line: # vbpef data       (comment, necessary)
    !     2nd-line: nbk (,ifbunp)      (number of k-line
    !                               ,flag to output distribution data)
    !     3rd-line: nkpt(i),i=1,nbk+1  (k-corner label character)
    !        .... : (ak(i,j),j=1,nbk+1),i=1,3 (k-corner vector)
    !        .... : nkfi(i),i=1,nbk    (num of mesh for each k-line)
    ! In case (ifbunp>0)
    !       nbba1,nbba2: upper and lower most bands to calculate
    !                            (if <=0: set default value:1,nw)
    !     (==1): distribution along an axis of a supercell
    !       nsph       : number of axes to calculate
    !       rmin,rmax  : the lower and upper bound (fractional coord.)
    !       iaxis,ndiv : axis to calc.(0-3;0=>all 1-3),number of division 
    !     (==2): radial distribution around rzero(3)
    !       nsph       : number of spheres(rzero,rmin,rmax,ndiv)
    !       (rzero(i),i=1,3),rmin,rmax,ndiv
    !         :center(fractional Coor.), radius(a.u.), number of division
    !     
    implicit none
    integer:: nbk,nw,nb2,itsb,ndiag,ifbunp,ifrho,nbba1,nbba2,nsph
    real(kind=8):: eps
    integer:: nf,mssg,ierr
    !     -- for data style check
    integer:: ios,i,j,is
    character(len=12):: cpef
    character(len=256):: cbuf
    !
    ! -- skip lines until '# vbpef data' appears.
    ierr = 1
    rewind(nf)
100 continue
    read (nf,'(A12)',end=999) cpef
    if (cpef.ne.'# vbpef data') goto 100
    !
    ! -- input vbpef data
    read (nf,'(a)') cbuf
    read (cbuf,*,IOSTAT=ios) nbk,ifbunp,ifrho
    if (ios.gt.0) then
       ifrho=0
       read(cbuf,*,IOSTAT=ios) nbk,ifbunp
       if (ios.gt.0) then
          !
          ! ifbunp does not exist.
          ifbunp=0
          read(cbuf,*) nbk
       end if
    else if (ios.lt.0) then
       if (mssg.gt.-1) write(6,*)'READ ERROR in RDPEF'
       return
    end if
    if ( (ifbunp .lt. 0) .or. (ifbunp .gt. 2) ) then
       if (mssg.gt.-1) write(6,*)'range error of ifbunp'
       return
    end if
    if ( (ifrho .lt. 0) .or. (ifrho .gt. 2) ) then
       if (mssg.gt.-1) write(6,*)'range error of ifrho'
       return
    end if
    allocate(nkpt(nbk+1),ak(3,nbk+1),nkfi(nbk))
    read(nf,*,END=998) (nkpt(i),i=1,nbk+1)
    do i=1,3
       read(nf,*,END=998) (ak(i,j),j=1,nbk+1)
    end do
    read(nf,*,END=998) (nkfi(i),i=1,nbk)
    read(nf,*,END=998) nw,nb2
    read(nf,*,END=998) itsb,ndiag,eps

    do i=1,nbk
       if (nkfi(i).lt.0) then
          if (mssg.gt.-1) write(6,*)'ERROR:NKFI(NBK) MUST BE >= 0'
          return
       end if
    end do
    !
    if ( (ifbunp.eq.0) .and. (ifrho.eq.0) ) then
       ierr = 0
       return
    end if
    read(nf,*) nbba1,nbba2
    if (ifbunp.eq.0) then
       nsph = 1
       allocate(iaxis(1),rmin(1),rmax(1),ndiv(1),rzero(3,1))
    else if (ifbunp.eq.1) then
       read(nf,*,END=998) nsph
       allocate(iaxis(nsph),rmin(nsph),rmax(nsph),ndiv(nsph),rzero(3,1))
       do is=1,nsph
          read(nf,*,END=998) iaxis(is),rmin(is),rmax(is),ndiv(is)
       end do
    else if (ifbunp.eq.2) then
       read(nf,*,END=998) nsph
       allocate(rzero(3,nsph),rmin(nsph),rmax(nsph),ndiv(nsph),iaxis(1))
       do is=1,nsph
          read(nf,*,END=998) &
               (rzero(i,is),i=1,3),rmin(is),rmax(is),ndiv(is)
       end do
    else
       return
    end if
    ierr = 0
    return
    !
998 continue
    if (mssg.gt.-1) write(6,*) 'Errors in VBPEF data'
    stop

999 continue
    return
  end subroutine rdpef

  subroutine rdwfn2chg(nfin,nw,ifbunp,ifrho,nbba1,nbba2 &
       ,nsph,itwav,nsi,mssg,ierr)
    implicit none
    integer nfin,nw
    integer ifbunp,ifrho,nbba1,nbba2,nsph,itwav,nsi
    integer:: ierr,mssg
    !
    character(len=14) cbuf
    integer i,is

    ierr = 0
    rewind(nfin)
    !
    ! -- skip lines until '# wfn2chg data' appears.
100 continue
    read (nfin,'(A14)',end=999) cbuf
    if (cbuf.ne.'# wfn2chg data') goto 100
    !
    ! -- input wfn2chg data
    read (nfin,*) ifbunp,ifrho
    !
    read(nfin,*)nbba1,nbba2
    if (nbba1.gt.nbba2) then
       if (mssg.gt.-1) write(6,'(1x,a)') 'nbba1 > nbba2'
       ierr = 1
       return
    end if
    if (nbba2.gt.nw) then
       if (mssg.gt.-1) write(6,'(1x,a)') 'nbba1 > nw'
       ierr = 1
       return
    end if

    if (ifbunp.eq.0) then
       nsph = 1
       allocate(iaxisw(1),rminw(1),rmaxw(1),ndivw(1),rzerow(3,1))
    else if (ifbunp.eq.1) then
       read(nfin,*,END=998)nsph
       allocate(iaxisw(nsph),rminw(nsph),rmaxw(nsph),ndivw(nsph),rzerow(3,1))
       do is=1,nsph
          read(nfin,*,END=998)iaxisw(is),rminw(is),rmaxw(is),ndivw(is)
       end do
    else if (ifbunp.eq.2) then
       read(nfin,*,END=998)nsph
       allocate(rzerow(3,nsph),rminw(nsph),rmaxw(nsph),ndivw(nsph),iaxisw(1))
       do is=1,nsph
          read(nfin,*,END=998) &
               (rzerow(i,is),i=1,3),rminw(is),rmaxw(is),ndivw(is)
       end do
    else if (ifbunp.eq.3) then
       nsph = 1
       allocate(iaxisw(1),rminw(1),rmaxw(1),ndivw(1),rzerow(3,1))
       read(nfin,*,END=998) itwav
       if (itwav.lt.0 .or. itwav.gt.nsi) then
          if (mssg.gt.-1) write(6,'(1x,a,i5)') 'out of range: itwav = ', itwav
          ierr = 1
          return
       end if
    else
       if (mssg.gt.-1) write(6,*) 'Errors in wfn2chg'
       ierr = 1
       return
    end if
    if ( (ifrho .lt. 0) .or. (ifrho .gt. 1) ) then
       if (mssg.gt.-1) then
          write(6,*) 'range error of ifrho'
          write(6,*) 'Errors in wfn2chg'
       end if
       ierr = 1
       return
    end if
    return
    !
998 continue
    if (mssg.gt.-1) write(6,*) 'Errors in wfn2chg data'
    ierr = 1
    stop

999 continue
    ierr = 1
    return
  end subroutine rdwfn2chg

  subroutine rdstm(nfin,eferm,vs,nbiasq,nbias,ierr)
    implicit none
    !
    integer nfin,nbiasq,nbias
    real(kind=8) eferm,vs(nbiasq)
    integer:: ierr
    !
    character(len=12) buff
    character(len=12) magic
    data magic/'# vbstm data'/
    integer i
    !
    ierr = 0
    rewind(nfin)
    !     skip lines
10  continue
    read(nfin,11,END=999) buff
11  format(a12)
    if (buff.ne.magic) goto 10
    !
    read(nfin,*) eferm
    read(nfin,*) nbias
    if (nbias .gt. nbiasq) then
       write(6,'(1x,a)')'nbiasq is too small'
       ierr = 2
       return
    end if
    do i=1,nbias
       read(nfin,*) vs(i)
    end do
    !
    return

999 continue
    ierr = 1
    return
  end subroutine rdstm

  subroutine rdmddat(nfin,mdmode,deltm,imdstp,emdstp,imtrw, &
       nkd,nsi,syskbt,syspext,va0,sysvol, &
       mdparam,mdstat,msgcycl,mssg,ierr)
    use chain_moldyn
    implicit none
    integer:: nfin,imdstp,emdstp,nkd,nsi,imtrw
    character(len=16):: mdmode
    real(kind=8):: deltm
    real(kind=8):: syskbt,syspext,va0,sysvol
!    real(kind=8):: mdparam(num_mdparam),mdstat(num_mdstat)
    real(kind=8):: mdparam(5),mdstat(6)
    integer:: msgcycl,mssg,ierr

    character(len=*),parameter:: magic = '#md data'
    character(len=256):: buf
    logical:: flg
    integer:: ikd, it, ios

    ierr = 0
    rewind(nfin)

    flg = .true.
    do while (flg)
       read(nfin,'(a)',END=999) buf
       if (trim(buf).eq.magic) then
          flg = .false.
       end if
    end do

    read(nfin,'(a256)') buf
    read(buf,*,IOSTAT=ios) mdmode, deltm, imdstp, emdstp, &
         imtrw, msgcycl
    if (ios .ne. 0) then
       msgcycl = 1
       read(buf,*,IOSTAT=ios) mdmode, deltm, imdstp, emdstp, &
            imtrw
       if (ios .ne. 0) then
          read(buf,*,IOSTAT=ios) mdmode, deltm, imdstp, emdstp
          imtrw = 1
       end if
    end if

    if (imtrw.lt.0 .or. imtrw.gt.2) then
       if (mssg.gt.-1) then
          write(6,'(1x,a,i3)') 'unsupported imtrw = ', imtrw
       end if
       stop
    end if

    read(nfin,*) (mass(ikd),ikd=1,nkd)

    if (mdmode .eq. 'SMPL') then
       sysvol = va0
       syskbt = 0.0d0
       syspext = 0.0d0
       return
    else
       do it=1,nsi
          read(nfin,*) cavl(1,it),cavl(2,it),cavl(3,it)
       end do
    end if

    mdparam = 0.0d0
    mdstat = 0.0d0
    read(nfin,'(a256)') buf
    if (mdmode .eq. 'NVE') then
       !
       !     read syskbt,sysvol
       !
       read(buf,*,IOSTAT=ios) syskbt,sysvol
       if (ios.ne.0) then
          read(buf,*,IOSTAT=ios) syskbt
          sysvol = va0
       end if
       if (ios.ne.0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'invalid mdparam or mdstat'
          stop
       end if
       syspext = 0.0d0
    else if (mdmode .eq. 'NPT_ST' .or. mdmode .eq. 'MBMT_ST') then
       !
       ! read syskbt,syspext,sysvol,omzeta,ometa,zeta,eta,sigma
       !
       read(buf,*,IOSTAT=ios) syskbt,syspext,sysvol, &
            mdparam(1),mdparam(2),mdstat(1),mdstat(2),mdstat(3)
       if (ios.ne.0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'invalid mdparam or mdstat'
          stop
       end if
       if (mdparam(1).lt.0.0d0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'omzeta is negative'
          stop
       end if
       if (mdparam(2).lt.0.0d0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'ometa is negative'
          stop
       end if
    else if (mdmode .eq. 'NPT_ST_R') then
       !
       ! read syskbt,syspext,sysvol,omzeta,ometa,zeta,eta,sigma,aicycl
       !
       read(buf,*,IOSTAT=ios) syskbt,syspext,sysvol, &
            mdparam(1),mdparam(2),mdstat(1),mdstat(2),mdstat(3), &
            mdparam(3)
       if (ios.ne.0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'invalid mdparam or mdstat'
          stop
       end if
       if (mdparam(1).lt.0.0d0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'omzeta is negative'
          stop
       end if
       if (mdparam(2).lt.0.0d0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'ometa is negative'
          stop
       end if
       if (int(mdparam(3))-mdparam(3).ne.0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'aicycl is fractional'
          stop
       end if

       ! set wlupdt to zero
       mdstat(6) = 0.0d0
       ! set wlwcycl,wlfcycl to -1
       mdparam(4) = -1
       mdparam(5) = -1

    else if (mdmode .eq. 'MBMT_ST_R' &
         .or. mdmode .eq. 'MT_ST_R') then
       !
       ! read syskbt,syspext,sysvol,omzeta,ometa,zeta,eta,sigma,aicycl,
       !      wlupdt,wlwcycl,wlfcycl
       !
       read(buf,*,IOSTAT=ios) syskbt,syspext,sysvol, &
            mdparam(1),mdparam(2),mdstat(1),mdstat(2),mdstat(3), &
            mdparam(3),mdstat(6),mdparam(4),mdparam(5)
       if (ios.ne.0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'invalid mdparam or mdstat'
          stop
       end if
       if (mdparam(1).lt.0.0d0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'omzeta is negative'
          stop
       end if
       if (mdparam(2).lt.0.0d0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'ometa is negative'
          stop
       end if
       if (int(mdparam(3))-mdparam(3).ne.0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'aicycl is fractional'
          stop
       end if
       if (mdstat(6).lt.0.0d0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'wlupdt is negative'
          stop
       end if
       if (mdparam(4).lt.0.0d0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'wlwcycl is negative'
          stop
       end if
       if (int(mdparam(4))-mdparam(4).ne.0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'wlwcycl is fractional'
          stop
       end if
       if (mdparam(5).le.mdparam(4)) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'wlfcycl <= wlwgtcycl'
          stop
       end if
       if (int(mdparam(5))-mdparam(5).ne.0) then
          if (mssg.gt.-1) write(6,'(1x,a)') 'wlfcycl is fractional'
          stop
       end if
    end if
    if (syskbt.lt.0.0d0) then
       if (mssg.gt.-1) write(6,'(1x,a)') 'syskbt is negative'
       stop
    end if
    if (sysvol.le.0.0d0) then
       if (mssg.gt.-1) write(6,'(1x,a)') 'sysvol is negative'
       stop
    end if

    return

999 continue
    ierr = 1
    return
  end subroutine rdmddat
end program old2new
