/* calculate minimun and maximum of each band */
/* Copyright (c) 2013 Yoshihide Yoshimoto */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXKPTNAME 256

typedef char name[MAXKPTNAME];
typedef double vector[3];

int main (int argc, char *argv[])
{
    int nbk, nw, nspin;
    name *kptname;
    int *kptsamp;
    int i, j, k, is, n;
    vector *kpts, *kp, dkp;
    double ***eig;
    int *minpt;
    int *maxpt;
	int *kp2blk;
	int *kp2blkbase;
	int blkbase,blk;

    scanf("%d %d %d", &nbk, &nw, &nspin);
    kptname = (name *) malloc((nbk+1)*sizeof(name));
    kptsamp = (int *) malloc(nbk*sizeof(int));
    kpts = (vector *) malloc((nbk+1)*sizeof(vector));
    for (i=0; i<=nbk; i++)
        {
            scanf("%s",kptname[i]);
        }
    n = 1;
    for (i=0; i<=nbk-1; i++)
        {
            scanf("%d",&kptsamp[i]);
            n = n + kptsamp[i];
        }
    kp = (vector *) malloc(n*sizeof(vector));

    kp2blk = (int *) malloc(n*sizeof(int));
    kp2blkbase = (int *) malloc(n*sizeof(int));
	i = 0;
    for (k=0; k<nbk; k++)
        {
			blkbase = i;
			for (j=0; j<kptsamp[k]; j++) {
				kp2blk[i] = k;
				kp2blkbase[i] = blkbase;
				i = i + 1;
			}
        }
	kp2blk[i] = nbk-1;
	kp2blkbase[i] = blkbase;

    eig = (double ***) malloc(n*sizeof(double **));
    for (j=0; j<=n; j++)
        {
            eig[j] = (double **) malloc(nspin*sizeof(double *));
			for (is=0; is<nspin; is++)
				{
					eig[j][is] = (double *) malloc(nw*sizeof(double));
				}
        }
    for (i=0; i<=nbk; i++)
        {
            scanf("%lf %lf %lf", &kpts[i][0], &kpts[i][1], &kpts[i][2]);
        }
    n = 0;
    for (j=0; j<=nbk-1; j++)
        {
            for (i=0; i<=2; i++)
                {
                    kp[n][i] = kpts[j][i];
                    dkp[i] = (kpts[j+1][i] - kpts[j][i])/kptsamp[j];
                }
            for (i=1; i<=kptsamp[j]; i++)
                {
					for (is=0; is<nspin; is++) {
						for (k=0; k<=nw-1; k++)
							{
								scanf("%lf", &eig[n][is][k]);
							}
					}
                    for (k=0; k<=2; k++)
                        {
                            kp[n+1][k] = kp[n][k] + dkp[k];
                        }
                    n = n + 1;
                }
        }
    for (i=0; i<=2; i++)
        {
            kp[n][i] = kpts[nbk][i];
        }
	for (is=0; is<nspin; is++) {
		for (k=0; k<=nw-1; k++)
			{
				scanf("%lf", &eig[n][is][k]);
			}
	}

    minpt = (int *)malloc(nw*sizeof(int));
    maxpt = (int *)malloc(nw*sizeof(int));

	for (is=0; is<nspin; is++)
		{
			for (j=0; j<=nw-1; j++)
				{
					minpt[j] = 0;
					maxpt[j] = 0;
					for (i=0; i<=n; i++)
						{
							if ( eig[i][is][j] < eig[minpt[j]][is][j] )
								{
									minpt[j] = i;
								}
							else if ( eig[i][is][j] > eig[maxpt[j]][is][j] )
								{
									maxpt[j] = i;
								}
						}
                }
			for (i=0; i<=nw-1; i++)
				{
					blk = kp2blk[minpt[i]];
					printf("%4d %s %s %9.6f %10.6f", i+1,
						   kptname[blk],kptname[blk+1],
						   (double)(minpt[i]-kp2blkbase[minpt[i]])/(double)kptsamp[blk],
						   eig[minpt[i]][is][i]);

					blk = kp2blk[maxpt[i]];
					printf("   %s %s %9.6f %10.6f\n",
						   kptname[blk],kptname[blk+1],
						   (double)(maxpt[i]-kp2blkbase[maxpt[i]])/(double)kptsamp[blk],
						   eig[maxpt[i]][is][i]);
				}
			printf("\n");
		}

    return 0;
}

/* Local Variables:   */
/* mode: c            */
/* tab-width: 4       */
/* c-basic-offset:  4 */
/* End:               */
